#![allow(dead_code)]
#![allow(mutable_transmutes)]
#![allow(non_camel_case_types)]
#![allow(non_snake_case)]
#![allow(non_upper_case_globals)]
#![allow(unused_assignments)]
#![allow(unused_mut)]
#![feature(asm)]
#![feature(c_variadic)]
#![feature(const_raw_ptr_to_usize_cast)]
#![feature(extern_types)]
#![feature(main)]
#![feature(ptr_wrapping_offset_from)]
#![feature(register_tool)]
#![register_tool(c2rust)]

#[path = "src/internal.rs"]
pub mod internal;
#[path = "src/squeezelite_h.rs"]
pub mod squeezelite_h;
#[path = "src/stdarg_h.rs"]
pub mod stdarg_h;
#[path = "src/stddef_h.rs"]
pub mod stddef_h;
#[path = "src/stdlib.rs"]
pub mod stdlib;
#[macro_use]
extern crate c2rust_bitfields;
#[macro_use]
extern crate c2rust_asm_casts;
extern crate libc;

pub mod src {
    pub mod buffer;
    pub mod decode;
    pub mod faad;
    pub mod flac;
    pub mod mad;
    pub mod mpg;
    pub mod output;
    pub mod output_alsa;
    pub mod output_pa;
    pub mod output_pack;
    pub mod output_pulse;
    pub mod output_stdout;
    pub mod pcm;
    pub mod slimproto;
    pub mod stream;
    pub mod utils;
    pub mod vorbis;
} // mod src
