use ::libc;

pub use crate::stddef_h::size_t;
pub use crate::stdlib::__int32_t;
pub use crate::stdlib::__uint32_t;
pub use crate::stdlib::__uint64_t;
pub use crate::stdlib::__uint8_t;
pub use crate::stdlib::int32_t;

pub use crate::stdlib::__pthread_internal_list;
pub use crate::stdlib::__pthread_list_t;
pub use crate::stdlib::__pthread_mutex_s;
pub use crate::stdlib::pthread_mutex_t;
pub use crate::stdlib::u_int32_t;
pub use crate::stdlib::u_int64_t;
pub use crate::stdlib::u_int8_t;

pub use crate::squeezelite_h::buffer;
pub use crate::squeezelite_h::codec;
pub use crate::squeezelite_h::decode_state;
pub use crate::squeezelite_h::decodestate;
pub use crate::squeezelite_h::disconnect_code;
pub use crate::squeezelite_h::fade_dir;
pub use crate::squeezelite_h::fade_mode;
pub use crate::squeezelite_h::fade_state;
pub use crate::squeezelite_h::frames_t;
pub use crate::squeezelite_h::lDEBUG;
pub use crate::squeezelite_h::lERROR;
pub use crate::squeezelite_h::lINFO;
pub use crate::squeezelite_h::lSDEBUG;
pub use crate::squeezelite_h::lWARN;
pub use crate::squeezelite_h::log_level;
pub use crate::squeezelite_h::output_format;
pub use crate::squeezelite_h::output_state;
pub use crate::squeezelite_h::outputstate;
pub use crate::squeezelite_h::s32_t;
pub use crate::squeezelite_h::stream_state;
pub use crate::squeezelite_h::streamstate;
pub use crate::squeezelite_h::u32_t;
pub use crate::squeezelite_h::u64_t;
pub use crate::squeezelite_h::u8_t;
pub use crate::squeezelite_h::C2RustUnnamed_1;
pub use crate::squeezelite_h::_buf_used;
pub use crate::squeezelite_h::DECODE_COMPLETE;
pub use crate::squeezelite_h::DECODE_ERROR;
pub use crate::squeezelite_h::DECODE_READY;
pub use crate::squeezelite_h::DECODE_RUNNING;
pub use crate::squeezelite_h::DECODE_STOPPED;
pub use crate::squeezelite_h::DISCONNECT;
pub use crate::squeezelite_h::DISCONNECT_OK;
pub use crate::squeezelite_h::FADE_ACTIVE;
pub use crate::squeezelite_h::FADE_CROSS;
pub use crate::squeezelite_h::FADE_CROSSFADE;
pub use crate::squeezelite_h::FADE_DOWN;
pub use crate::squeezelite_h::FADE_DUE;
pub use crate::squeezelite_h::FADE_IN;
pub use crate::squeezelite_h::FADE_INACTIVE;
pub use crate::squeezelite_h::FADE_INOUT;
pub use crate::squeezelite_h::FADE_NONE;
pub use crate::squeezelite_h::FADE_OUT;
pub use crate::squeezelite_h::FADE_UP;
pub use crate::squeezelite_h::LOCAL_DISCONNECT;
pub use crate::squeezelite_h::OUTPUT_BUFFER;
pub use crate::squeezelite_h::OUTPUT_OFF;
pub use crate::squeezelite_h::OUTPUT_PAUSE_FRAMES;
pub use crate::squeezelite_h::OUTPUT_RUNNING;
pub use crate::squeezelite_h::OUTPUT_SKIP_FRAMES;
pub use crate::squeezelite_h::OUTPUT_START_AT;
pub use crate::squeezelite_h::OUTPUT_STOPPED;
pub use crate::squeezelite_h::RECV_HEADERS;
pub use crate::squeezelite_h::REMOTE_DISCONNECT;
pub use crate::squeezelite_h::S16_LE;
pub use crate::squeezelite_h::S24_3LE;
pub use crate::squeezelite_h::S24_LE;
pub use crate::squeezelite_h::S32_LE;
pub use crate::squeezelite_h::SEND_HEADERS;
pub use crate::squeezelite_h::STOPPED;
pub use crate::squeezelite_h::STREAMING_BUFFERING;
pub use crate::squeezelite_h::STREAMING_FILE;
pub use crate::squeezelite_h::STREAMING_HTTP;
pub use crate::squeezelite_h::STREAMING_WAIT;
pub use crate::squeezelite_h::TIMEOUT;
pub use crate::squeezelite_h::UNREACHABLE;
pub use crate::src::buffer::_buf_cont_read;
pub use crate::src::buffer::_buf_cont_write;
pub use crate::src::buffer::_buf_inc_readp;
pub use crate::src::buffer::_buf_inc_writep;
pub use crate::src::buffer::_buf_space;
pub use crate::src::decode::decode_newstream;
pub use crate::src::output::_checkfade;
pub use crate::src::utils::logprint;
pub use crate::src::utils::logtime;
pub use crate::src::utils::unpackN;
use crate::stdlib::dlerror;
use crate::stdlib::dlopen;
use crate::stdlib::dlsym;
use crate::stdlib::free;
pub use crate::stdlib::mad_bitptr;
pub use crate::stdlib::mad_emphasis;
pub use crate::stdlib::mad_error;
pub use crate::stdlib::mad_fixed_t;
pub use crate::stdlib::mad_frame;
pub use crate::stdlib::mad_header;
pub use crate::stdlib::mad_layer;
pub use crate::stdlib::mad_mode;
pub use crate::stdlib::mad_pcm;
pub use crate::stdlib::mad_stream;
pub use crate::stdlib::mad_synth;
pub use crate::stdlib::mad_timer_t;
use crate::stdlib::malloc;
use crate::stdlib::memcmp;
use crate::stdlib::memcpy;
use crate::stdlib::memmove;
use crate::stdlib::memset;
use crate::stdlib::pthread_mutex_lock;
use crate::stdlib::pthread_mutex_unlock;
pub use crate::stdlib::MAD_EMPHASIS_50_15_US;
pub use crate::stdlib::MAD_EMPHASIS_CCITT_J_17;
pub use crate::stdlib::MAD_EMPHASIS_NONE;
pub use crate::stdlib::MAD_EMPHASIS_RESERVED;
pub use crate::stdlib::MAD_ERROR_BADBIGVALUES;
pub use crate::stdlib::MAD_ERROR_BADBITALLOC;
pub use crate::stdlib::MAD_ERROR_BADBITRATE;
pub use crate::stdlib::MAD_ERROR_BADBLOCKTYPE;
pub use crate::stdlib::MAD_ERROR_BADCRC;
pub use crate::stdlib::MAD_ERROR_BADDATAPTR;
pub use crate::stdlib::MAD_ERROR_BADEMPHASIS;
pub use crate::stdlib::MAD_ERROR_BADFRAMELEN;
pub use crate::stdlib::MAD_ERROR_BADHUFFDATA;
pub use crate::stdlib::MAD_ERROR_BADHUFFTABLE;
pub use crate::stdlib::MAD_ERROR_BADLAYER;
pub use crate::stdlib::MAD_ERROR_BADMODE;
pub use crate::stdlib::MAD_ERROR_BADPART3LEN;
pub use crate::stdlib::MAD_ERROR_BADSAMPLERATE;
pub use crate::stdlib::MAD_ERROR_BADSCALEFACTOR;
pub use crate::stdlib::MAD_ERROR_BADSCFSI;
pub use crate::stdlib::MAD_ERROR_BADSTEREO;
pub use crate::stdlib::MAD_ERROR_BUFLEN;
pub use crate::stdlib::MAD_ERROR_BUFPTR;
pub use crate::stdlib::MAD_ERROR_LOSTSYNC;
pub use crate::stdlib::MAD_ERROR_NOMEM;
pub use crate::stdlib::MAD_ERROR_NONE;
pub use crate::stdlib::MAD_LAYER_I;
pub use crate::stdlib::MAD_LAYER_II;
pub use crate::stdlib::MAD_LAYER_III;
pub use crate::stdlib::MAD_MODE_DUAL_CHANNEL;
pub use crate::stdlib::MAD_MODE_JOINT_STEREO;
pub use crate::stdlib::MAD_MODE_SINGLE_CHANNEL;
pub use crate::stdlib::MAD_MODE_STEREO;
extern "C" {
    #[no_mangle]
    pub static mut loglevel: crate::squeezelite_h::log_level;
    #[no_mangle]
    pub static mut streambuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut outputbuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut stream: crate::squeezelite_h::streamstate;
    #[no_mangle]
    pub static mut output: crate::squeezelite_h::outputstate;
    #[no_mangle]
    pub static mut decode: crate::squeezelite_h::decodestate;
}
// local buffer used by decoder: FIXME merge with any other decoders needing one?

#[repr(C)]
#[derive(Copy, Clone)]
pub struct mad {
    pub readbuf: *mut crate::squeezelite_h::u8_t,
    pub readbuf_len: libc::c_uint,
    pub stream: crate::stdlib::mad_stream,
    pub frame: crate::stdlib::mad_frame,
    pub synth: crate::stdlib::mad_synth,
    pub last_error: crate::stdlib::mad_error,
    pub checktags: libc::c_int,
    pub consume: crate::squeezelite_h::u32_t,
    pub skip: crate::squeezelite_h::u32_t,
    pub samples: crate::squeezelite_h::u64_t,
    pub padding: crate::squeezelite_h::u32_t,
    pub mad_stream_init: Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_stream) -> ()>,
    pub mad_frame_init: Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_frame) -> ()>,
    pub mad_synth_init: Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_synth) -> ()>,
    pub mad_frame_finish: Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_frame) -> ()>,
    pub mad_stream_finish: Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_stream) -> ()>,
    pub mad_stream_buffer: Option<
        unsafe extern "C" fn(
            _: *mut crate::stdlib::mad_stream,
            _: *const libc::c_uchar,
            _: libc::c_ulong,
        ) -> (),
    >,
    pub mad_frame_decode: Option<
        unsafe extern "C" fn(
            _: *mut crate::stdlib::mad_frame,
            _: *mut crate::stdlib::mad_stream,
        ) -> libc::c_int,
    >,
    pub mad_synth_frame: Option<
        unsafe extern "C" fn(
            _: *mut crate::stdlib::mad_synth,
            _: *const crate::stdlib::mad_frame,
        ) -> (),
    >,
    pub mad_stream_errorstr:
        Option<unsafe extern "C" fn(_: *const crate::stdlib::mad_stream) -> *const libc::c_char>,
}

static mut m: *mut mad = 0 as *const mad as *mut mad;
// based on libmad minimad.c scale
#[inline]

unsafe extern "C" fn scale(mut sample: crate::stdlib::mad_fixed_t) -> crate::squeezelite_h::u32_t {
    sample = (sample as libc::c_long
        + ((1 as libc::c_long) << 28 as libc::c_int - 24 as libc::c_int))
        as crate::stdlib::mad_fixed_t;
    if sample >= 0x10000000 as libc::c_long as crate::stdlib::mad_fixed_t {
        sample = 0x10000000 as libc::c_long as crate::stdlib::mad_fixed_t - 1 as libc::c_int
    } else if sample < -(0x10000000 as libc::c_long as crate::stdlib::mad_fixed_t) {
        sample = -(0x10000000 as libc::c_long as crate::stdlib::mad_fixed_t)
    }
    return ((sample >> 28 as libc::c_int + 1 as libc::c_int - 24 as libc::c_int)
        << 8 as libc::c_int) as crate::squeezelite_h::u32_t;
}
// check for id3.2 tag at start of file - http://id3.org/id3v2.4.0-structure, return length

unsafe extern "C" fn _check_id3_tag(mut bytes: crate::stddef_h::size_t) -> libc::c_uint {
    let mut ptr = (*streambuf).readp;
    let mut size = 0 as libc::c_int as crate::squeezelite_h::u32_t;
    if bytes > 10 as libc::c_int as libc::c_ulong
        && *ptr as libc::c_int == 'I' as i32
        && *ptr.offset(1 as libc::c_int as isize) as libc::c_int == 'D' as i32
        && *ptr.offset(2 as libc::c_int as isize) as libc::c_int == '3' as i32
    {
        // size is encoded as syncsafe integer, add 10 if footer present
        if (*ptr.offset(6 as libc::c_int as isize) as libc::c_int) < 0x80 as libc::c_int
            && (*ptr.offset(7 as libc::c_int as isize) as libc::c_int) < 0x80 as libc::c_int
            && (*ptr.offset(8 as libc::c_int as isize) as libc::c_int) < 0x80 as libc::c_int
            && (*ptr.offset(9 as libc::c_int as isize) as libc::c_int) < 0x80 as libc::c_int
        {
            size = (10 as libc::c_int
                + ((*ptr.offset(6 as libc::c_int as isize) as libc::c_int) << 21 as libc::c_int)
                + ((*ptr.offset(7 as libc::c_int as isize) as libc::c_int) << 14 as libc::c_int)
                + ((*ptr.offset(8 as libc::c_int as isize) as libc::c_int) << 7 as libc::c_int)
                + *ptr.offset(9 as libc::c_int as isize) as libc::c_int
                + (if *ptr.offset(5 as libc::c_int as isize) as libc::c_int & 0x10 as libc::c_int
                    != 0
                {
                    10 as libc::c_int
                } else {
                    0 as libc::c_int
                })) as crate::squeezelite_h::u32_t;
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d id3.2 tag len: %u\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 15], &[libc::c_char; 15]>(
                        b"_check_id3_tag\x00",
                    ))
                    .as_ptr(),
                    111 as libc::c_int,
                    size,
                );
            }
        }
    }
    return size;
}
// check for lame gapless params, don't advance streambuf

unsafe extern "C" fn _check_lame_header(mut bytes: crate::stddef_h::size_t) {
    let mut ptr = (*streambuf).readp;
    if *ptr as libc::c_int == 0xff as libc::c_int
        && *ptr.offset(1 as libc::c_int as isize) as libc::c_int & 0xf0 as libc::c_int
            == 0xf0 as libc::c_int
        && bytes > 180 as libc::c_int as libc::c_ulong
    {
        let mut frame_count = 0 as libc::c_int as crate::squeezelite_h::u32_t;
        let mut enc_delay = 0 as libc::c_int as crate::squeezelite_h::u32_t;
        let mut enc_padding = 0 as libc::c_int as crate::squeezelite_h::u32_t;
        let mut flags: crate::squeezelite_h::u8_t = 0;
        // 2 channels
        if crate::stdlib::memcmp(
            ptr.offset(36 as libc::c_int as isize) as *const libc::c_void,
            b"Xing\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
            4 as libc::c_int as libc::c_ulong,
        ) == 0
            || crate::stdlib::memcmp(
                ptr.offset(36 as libc::c_int as isize) as *const libc::c_void,
                b"Info\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                4 as libc::c_int as libc::c_ulong,
            ) == 0
        {
            ptr = ptr.offset((36 as libc::c_int + 7 as libc::c_int) as isize)
        // mono
        } else if crate::stdlib::memcmp(
            ptr.offset(21 as libc::c_int as isize) as *const libc::c_void,
            b"Xing\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
            4 as libc::c_int as libc::c_ulong,
        ) == 0
            || crate::stdlib::memcmp(
                ptr.offset(21 as libc::c_int as isize) as *const libc::c_void,
                b"Info\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                4 as libc::c_int as libc::c_ulong,
            ) == 0
        {
            ptr = ptr.offset((21 as libc::c_int + 7 as libc::c_int) as isize)
        }
        flags = *ptr;
        if flags as libc::c_int & 0x1 as libc::c_int != 0 {
            frame_count = crate::src::utils::unpackN(
                ptr.offset(1 as libc::c_int as isize) as *mut crate::squeezelite_h::u32_t
            );
            ptr = ptr.offset(4 as libc::c_int as isize)
        }
        if flags as libc::c_int & 0x2 as libc::c_int != 0 {
            ptr = ptr.offset(4 as libc::c_int as isize)
        }
        if flags as libc::c_int & 0x4 as libc::c_int != 0 {
            ptr = ptr.offset(100 as libc::c_int as isize)
        }
        if flags as libc::c_int & 0x8 as libc::c_int != 0 {
            ptr = ptr.offset(4 as libc::c_int as isize)
        }
        if crate::stdlib::memcmp(
            ptr.offset(1 as libc::c_int as isize) as *const libc::c_void,
            b"LAME\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
            4 as libc::c_int as libc::c_ulong,
        ) != 0
        {
            return;
        }
        ptr = ptr.offset(22 as libc::c_int as isize);
        enc_delay = (((*ptr as libc::c_int) << 4 as libc::c_int
            | *ptr.offset(1 as libc::c_int as isize) as libc::c_int >> 4 as libc::c_int)
            + 529 as libc::c_int) as crate::squeezelite_h::u32_t;
        enc_padding = ((*ptr.offset(1 as libc::c_int as isize) as libc::c_int & 0xf as libc::c_int)
            << 8 as libc::c_int
            | *ptr.offset(2 as libc::c_int as isize) as libc::c_int)
            as crate::squeezelite_h::u32_t;
        enc_padding = if enc_padding > 529 as libc::c_int as libc::c_uint {
            enc_padding.wrapping_sub(529 as libc::c_int as libc::c_uint)
        } else {
            0 as libc::c_int as libc::c_uint
        };
        // add one frame to initial skip for this (empty) frame
        (*m).skip = enc_delay.wrapping_add(1152 as libc::c_int as libc::c_uint);
        (*m).samples = frame_count
            .wrapping_mul(1152 as libc::c_int as libc::c_uint)
            .wrapping_sub(enc_delay)
            .wrapping_sub(enc_padding) as crate::squeezelite_h::u64_t;
        (*m).padding = enc_padding;
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d gapless: skip: %u samples: %lu delay: %u padding: %u\n\x00" as *const u8
                    as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 19], &[libc::c_char; 19]>(
                    b"_check_lame_header\x00",
                ))
                .as_ptr(),
                160 as libc::c_int,
                (*m).skip,
                (*m).samples,
                enc_delay,
                enc_padding,
            );
        }
    };
}

unsafe extern "C" fn mad_decode() -> crate::squeezelite_h::decode_state {
    let mut bytes: crate::stddef_h::size_t = 0;
    let mut eos = 0 as libc::c_int != 0;
    crate::stdlib::pthread_mutex_lock(&mut (*streambuf).mutex);
    bytes = if crate::squeezelite_h::_buf_used(streambuf)
        < crate::src::buffer::_buf_cont_read(streambuf)
    {
        crate::squeezelite_h::_buf_used(streambuf)
    } else {
        crate::src::buffer::_buf_cont_read(streambuf)
    } as crate::stddef_h::size_t;
    if (*m).checktags != 0 {
        if (*m).checktags == 1 as libc::c_int {
            (*m).consume = _check_id3_tag(bytes);
            (*m).checktags = 2 as libc::c_int
        }
        if (*m).consume != 0 {
            let mut consume = if ((*m).consume as libc::c_ulong) < bytes {
                (*m).consume as libc::c_ulong
            } else {
                bytes
            } as crate::squeezelite_h::u32_t;
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d consume: %u of %u\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mad_decode\x00"))
                        .as_ptr(),
                    178 as libc::c_int,
                    consume,
                    (*m).consume,
                );
            }
            crate::src::buffer::_buf_inc_readp(streambuf, consume);
            (*m).consume = ((*m).consume as libc::c_uint).wrapping_sub(consume)
                as crate::squeezelite_h::u32_t
                as crate::squeezelite_h::u32_t;
            crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
            return crate::squeezelite_h::DECODE_RUNNING;
        }
        if (*m).checktags == 2 as libc::c_int {
            if stream.meta_interval == 0 {
                _check_lame_header(bytes);
            }
            (*m).checktags = 0 as libc::c_int
        }
    }
    if !(*m).stream.next_frame.is_null() && (*m).readbuf_len != 0 {
        (*m).readbuf_len = ((*m).readbuf_len as libc::c_long
            - (*m).stream.next_frame.wrapping_offset_from((*m).readbuf) as libc::c_long)
            as libc::c_uint;
        crate::stdlib::memmove(
            (*m).readbuf as *mut libc::c_void,
            (*m).stream.next_frame as *const libc::c_void,
            (*m).readbuf_len as libc::c_ulong,
        );
    }
    bytes = if bytes
        < (2048 as libc::c_int as libc::c_uint).wrapping_sub((*m).readbuf_len) as libc::c_ulong
    {
        bytes
    } else {
        (2048 as libc::c_int as libc::c_uint).wrapping_sub((*m).readbuf_len) as libc::c_ulong
    };
    crate::stdlib::memcpy(
        (*m).readbuf.offset((*m).readbuf_len as isize) as *mut libc::c_void,
        (*streambuf).readp as *const libc::c_void,
        bytes,
    );
    (*m).readbuf_len =
        ((*m).readbuf_len as libc::c_ulong).wrapping_add(bytes) as libc::c_uint as libc::c_uint;
    crate::src::buffer::_buf_inc_readp(streambuf, bytes as libc::c_uint);
    if stream.state as libc::c_uint
        <= crate::squeezelite_h::DISCONNECT as libc::c_int as libc::c_uint
        && crate::squeezelite_h::_buf_used(streambuf) == 0 as libc::c_int as libc::c_uint
    {
        eos = 1 as libc::c_int != 0;
        if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d end of stream\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mad_decode\x00"))
                    .as_ptr(),
                204 as libc::c_int,
            );
        }
        crate::stdlib::memset(
            (*m).readbuf.offset((*m).readbuf_len as isize) as *mut libc::c_void,
            0 as libc::c_int,
            8 as libc::c_int as libc::c_ulong,
        );
        (*m).readbuf_len = (*m)
            .readbuf_len
            .wrapping_add(8 as libc::c_int as libc::c_uint)
    }
    crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
    (*m).mad_stream_buffer.expect("non-null function pointer")(
        &mut (*m).stream,
        (*m).readbuf,
        (*m).readbuf_len as libc::c_ulong,
    );
    loop {
        let mut frames: crate::stddef_h::size_t = 0;
        let mut iptrl = 0 as *mut crate::squeezelite_h::s32_t;
        let mut iptrr = 0 as *mut crate::squeezelite_h::s32_t;
        let mut max_frames: libc::c_uint = 0;
        if (*m).mad_frame_decode.expect("non-null function pointer")(
            &mut (*m).frame,
            &mut (*m).stream,
        ) == -(1 as libc::c_int)
        {
            let mut ret = crate::squeezelite_h::DECODE_STOPPED;
            if !eos
                && (*m).stream.error as libc::c_uint
                    == crate::stdlib::MAD_ERROR_BUFLEN as libc::c_int as libc::c_uint
            {
                ret = crate::squeezelite_h::DECODE_RUNNING
            } else if eos as libc::c_int != 0
                && ((*m).stream.error as libc::c_uint
                    == crate::stdlib::MAD_ERROR_BUFLEN as libc::c_int as libc::c_uint
                    || (*m).stream.error as libc::c_uint
                        == crate::stdlib::MAD_ERROR_LOSTSYNC as libc::c_int as libc::c_uint
                    || (*m).stream.error as libc::c_uint
                        == crate::stdlib::MAD_ERROR_BADBITRATE as libc::c_int as libc::c_uint)
            {
                ret = crate::squeezelite_h::DECODE_COMPLETE
            } else if (*m).stream.error as libc::c_uint & 0xff00 as libc::c_int as libc::c_uint == 0
            {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d mad_frame_decode error: %s - stopping decoder\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(
                            b"mad_decode\x00",
                        ))
                        .as_ptr(),
                        227 as libc::c_int,
                        (*m).mad_stream_errorstr.expect("non-null function pointer")(
                            &mut (*m).stream,
                        ),
                    );
                }
                ret = crate::squeezelite_h::DECODE_COMPLETE
            } else {
                if (*m).stream.error as libc::c_uint != (*m).last_error as libc::c_uint {
                    // suppress repeat error messages
                    if loglevel as libc::c_uint
                        >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
                    {
                        crate::src::utils::logprint(
                            b"%s %s:%d mad_frame_decode error: %s\n\x00" as *const u8
                                as *const libc::c_char,
                            crate::src::utils::logtime(),
                            (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(
                                b"mad_decode\x00",
                            ))
                            .as_ptr(),
                            232 as libc::c_int,
                            (*m).mad_stream_errorstr.expect("non-null function pointer")(
                                &mut (*m).stream,
                            ),
                        );
                    }
                }
                ret = crate::squeezelite_h::DECODE_RUNNING
            }
            (*m).last_error = (*m).stream.error;
            return ret;
        }
        (*m).mad_synth_frame.expect("non-null function pointer")(&mut (*m).synth, &mut (*m).frame);
        if decode.new_stream {
            crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d setting track_start\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mad_decode\x00"))
                        .as_ptr(),
                    244 as libc::c_int,
                );
            }
            output.next_sample_rate = crate::src::decode::decode_newstream(
                (*m).synth.pcm.samplerate,
                output.supported_rates.as_mut_ptr(),
            );
            output.track_start = (*outputbuf).writep;
            if output.fade_mode as u64 != 0 {
                crate::src::output::_checkfade(1 as libc::c_int != 0);
            }
            decode.new_stream = 0 as libc::c_int != 0;
            crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
        }
        crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
        max_frames = crate::src::buffer::_buf_space(outputbuf)
            .wrapping_div(8 as libc::c_int as libc::c_uint);
        if (*m).synth.pcm.length as libc::c_uint > max_frames {
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d too many samples - dropping samples\n\x00" as *const u8
                        as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mad_decode\x00"))
                        .as_ptr(),
                    263 as libc::c_int,
                );
            }
            (*m).synth.pcm.length = max_frames as libc::c_ushort
        }
        frames = (*m).synth.pcm.length as crate::stddef_h::size_t;
        iptrl = (*m).synth.pcm.samples[0 as libc::c_int as usize].as_mut_ptr();
        iptrr = (*m).synth.pcm.samples
            [((*m).synth.pcm.channels as libc::c_int - 1 as libc::c_int) as usize]
            .as_mut_ptr();
        if (*m).skip != 0 {
            let mut skip = if ((*m).skip as libc::c_ulong) < frames {
                (*m).skip as libc::c_ulong
            } else {
                frames
            } as crate::squeezelite_h::u32_t;
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d gapless: skipping %u frames at start\n\x00" as *const u8
                        as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mad_decode\x00"))
                        .as_ptr(),
                    273 as libc::c_int,
                    skip,
                );
            }
            frames = (frames as libc::c_ulong).wrapping_sub(skip as libc::c_ulong)
                as crate::stddef_h::size_t as crate::stddef_h::size_t;
            (*m).skip = ((*m).skip as libc::c_uint).wrapping_sub(skip)
                as crate::squeezelite_h::u32_t
                as crate::squeezelite_h::u32_t;
            iptrl = iptrl.offset(skip as isize);
            iptrr = iptrr.offset(skip as isize)
        }
        if (*m).samples != 0 {
            if (*m).samples < frames {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d gapless: trimming %u frames from end\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(
                            b"mad_decode\x00",
                        ))
                        .as_ptr(),
                        282 as libc::c_int,
                        frames.wrapping_sub((*m).samples),
                    );
                }
                frames = (*m).samples
            }
            (*m).samples = ((*m).samples as libc::c_ulong).wrapping_sub(frames)
                as crate::squeezelite_h::u64_t
                as crate::squeezelite_h::u64_t;
            if (*m).samples > 0 as libc::c_int as libc::c_ulong
                && eos as libc::c_int != 0
                && !(*(*m).stream.next_frame.offset(0 as libc::c_int as isize) as libc::c_int
                    == 0xff as libc::c_int
                    && *(*m).stream.next_frame.offset(1 as libc::c_int as isize) as libc::c_int
                        & 0xf0 as libc::c_int
                        == 0xf0 as libc::c_int)
            {
                // this is the last frame to be decoded, but more samples expected so we must have skipped, remove padding
                // note this only works if the padding is less than one frame of 1152 bytes otherswise some gap will remain
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d gapless: early end - trimming padding from end\n\x00"
                            as *const u8 as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(
                            b"mad_decode\x00",
                        ))
                        .as_ptr(),
                        289 as libc::c_int,
                    );
                }
                if frames >= (*m).padding as libc::c_ulong {
                    frames = (frames as libc::c_ulong).wrapping_sub((*m).padding as libc::c_ulong)
                        as crate::stddef_h::size_t
                        as crate::stddef_h::size_t
                } else {
                    frames = 0 as libc::c_int as crate::stddef_h::size_t
                }
                (*m).samples = 0 as libc::c_int as crate::squeezelite_h::u64_t
            }
        }
        if loglevel as libc::c_uint >= crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint
        {
            crate::src::utils::logprint(
                b"%s %s:%d write %u frames\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mad_decode\x00"))
                    .as_ptr(),
                299 as libc::c_int,
                frames,
            );
        }
        while frames > 0 as libc::c_int as libc::c_ulong {
            let mut f: crate::stddef_h::size_t = 0;
            let mut count: crate::stddef_h::size_t = 0;
            let mut optr = 0 as *mut crate::squeezelite_h::s32_t;
            f = if frames
                < crate::src::buffer::_buf_cont_write(outputbuf)
                    .wrapping_div(8 as libc::c_int as libc::c_uint)
                    as libc::c_ulong
            {
                frames
            } else {
                crate::src::buffer::_buf_cont_write(outputbuf)
                    .wrapping_div(8 as libc::c_int as libc::c_uint) as libc::c_ulong
            };
            optr = (*outputbuf).writep as *mut crate::squeezelite_h::s32_t;
            count = f;
            loop {
                let fresh0 = count;
                count = count.wrapping_sub(1);
                if !(fresh0 != 0) {
                    break;
                }
                let fresh1 = iptrl;
                iptrl = iptrl.offset(1);
                let fresh2 = optr;
                optr = optr.offset(1);
                *fresh2 = scale(*fresh1) as crate::squeezelite_h::s32_t;
                let fresh3 = iptrr;
                iptrr = iptrr.offset(1);
                let fresh4 = optr;
                optr = optr.offset(1);
                *fresh4 = scale(*fresh3) as crate::squeezelite_h::s32_t
            }
            frames = (frames as libc::c_ulong).wrapping_sub(f) as crate::stddef_h::size_t
                as crate::stddef_h::size_t;
            crate::src::buffer::_buf_inc_writep(
                outputbuf,
                f.wrapping_mul(8 as libc::c_int as libc::c_ulong) as libc::c_uint,
            );
        }
        crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
    }
}

unsafe extern "C" fn mad_open(
    mut size: crate::squeezelite_h::u8_t,
    mut rate: crate::squeezelite_h::u8_t,
    mut chan: crate::squeezelite_h::u8_t,
    mut endianness: crate::squeezelite_h::u8_t,
) {
    if (*m).readbuf.is_null() {
        (*m).readbuf =
            crate::stdlib::malloc((2048 as libc::c_int + 8 as libc::c_int) as libc::c_ulong)
                as *mut crate::squeezelite_h::u8_t
    }
    (*m).checktags = 1 as libc::c_int;
    (*m).consume = 0 as libc::c_int as crate::squeezelite_h::u32_t;
    (*m).skip = 529 as libc::c_int as crate::squeezelite_h::u32_t;
    (*m).samples = 0 as libc::c_int as crate::squeezelite_h::u64_t;
    (*m).readbuf_len = 0 as libc::c_int as libc::c_uint;
    (*m).last_error = crate::stdlib::MAD_ERROR_NONE;
    (*m).mad_stream_init.expect("non-null function pointer")(&mut (*m).stream);
    (*m).mad_frame_init.expect("non-null function pointer")(&mut (*m).frame);
    (*m).mad_synth_init.expect("non-null function pointer")(&mut (*m).synth);
}

unsafe extern "C" fn mad_close() {
    // macro only in current version
    (*m).mad_frame_finish.expect("non-null function pointer")(&mut (*m).frame);
    (*m).mad_stream_finish.expect("non-null function pointer")(&mut (*m).stream);
    crate::stdlib::free((*m).readbuf as *mut libc::c_void);
    (*m).readbuf = 0 as *mut crate::squeezelite_h::u8_t;
}

unsafe extern "C" fn load_mad() -> bool {
    let mut handle = crate::stdlib::dlopen(
        b"libmad.so.0\x00" as *const u8 as *const libc::c_char,
        0x2 as libc::c_int,
    );
    let mut err = 0 as *mut libc::c_char;
    if handle.is_null() {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d dlerror: %s\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"load_mad\x00")).as_ptr(),
                366 as libc::c_int,
                crate::stdlib::dlerror(),
            );
        }
        return 0 as libc::c_int != 0;
    }
    (*m).mad_stream_init = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_stream) -> ()>,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_stream_init\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mad_frame_init = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_frame) -> ()>,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_frame_init\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mad_synth_init = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_synth) -> ()>,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_synth_init\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mad_frame_finish = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_frame) -> ()>,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_frame_finish\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mad_stream_finish = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mad_stream) -> ()>,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_stream_finish\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mad_stream_buffer = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<
            unsafe extern "C" fn(
                _: *mut crate::stdlib::mad_stream,
                _: *const libc::c_uchar,
                _: libc::c_ulong,
            ) -> (),
        >,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_stream_buffer\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mad_frame_decode = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<
            unsafe extern "C" fn(
                _: *mut crate::stdlib::mad_frame,
                _: *mut crate::stdlib::mad_stream,
            ) -> libc::c_int,
        >,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_frame_decode\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mad_synth_frame = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<
            unsafe extern "C" fn(
                _: *mut crate::stdlib::mad_synth,
                _: *const crate::stdlib::mad_frame,
            ) -> (),
        >,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_synth_frame\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mad_stream_errorstr = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *const crate::stdlib::mad_stream) -> *const libc::c_char>,
    >(crate::stdlib::dlsym(
        handle,
        b"mad_stream_errorstr\x00" as *const u8 as *const libc::c_char,
    ));
    err = crate::stdlib::dlerror();
    if !err.is_null() {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d dlerror: %s\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"load_mad\x00")).as_ptr(),
                381 as libc::c_int,
                err,
            );
        }
        return 0 as libc::c_int != 0;
    }
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d loaded libmad.so.0\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"load_mad\x00")).as_ptr(),
            385 as libc::c_int,
        );
    }
    return 1 as libc::c_int != 0;
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
// output_pack.c
// output_vis.c
// dop.c
// codecs
#[no_mangle]

pub unsafe extern "C" fn register_mad() -> *mut crate::squeezelite_h::codec {
    static mut ret: crate::squeezelite_h::codec = unsafe {
        {
            let mut init = crate::squeezelite_h::codec {
                id: 'm' as i32 as libc::c_char,
                types: b"mp3\x00" as *const u8 as *const libc::c_char as *mut libc::c_char,
                min_read_bytes: 2048 as libc::c_int as libc::c_uint,
                min_space: 206800 as libc::c_int as libc::c_uint,
                open: Some(
                    mad_open
                        as unsafe extern "C" fn(
                            _: crate::squeezelite_h::u8_t,
                            _: crate::squeezelite_h::u8_t,
                            _: crate::squeezelite_h::u8_t,
                            _: crate::squeezelite_h::u8_t,
                        ) -> (),
                ),
                close: Some(mad_close as unsafe extern "C" fn() -> ()),
                decode: Some(
                    mad_decode as unsafe extern "C" fn() -> crate::squeezelite_h::decode_state,
                ),
            };
            init
        }
    };
    m = crate::stdlib::malloc(::std::mem::size_of::<mad>() as libc::c_ulong) as *mut mad;
    if m.is_null() {
        return 0 as *mut crate::squeezelite_h::codec;
    }
    (*m).readbuf = 0 as *mut crate::squeezelite_h::u8_t;
    (*m).readbuf_len = 0 as libc::c_int as libc::c_uint;
    if !load_mad() {
        return 0 as *mut crate::squeezelite_h::codec;
    }
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d using mad to decode mp3\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"register_mad\x00"))
                .as_ptr(),
            414 as libc::c_int,
        );
    }
    return &mut ret;
}
